/**
 * 
 */
package buffered;

import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.IOException;
import java.util.List;

/**
 * @author pvassil
 *
 */
public class Reporter {

	public void reportToTabbedTextFile(String filePath, List<String> stringList) throws IOException {
		if(stringList.size()==0)
			return;

		BufferedWriter bufferedWriter = null;
		try {
			bufferedWriter = new BufferedWriter(new FileWriter(filePath, false));
			
			formatAndOutputInputStringList(stringList, bufferedWriter);

			bufferedWriter.close();
		} catch (IOException e) {
			String msg = "IOException: Trying to work with file " + filePath + "for output";
			throw new IOException("\n" + msg + "\n" + e.getLocalizedMessage() + "\n");
		}
		System.out.println("Done with producing " + filePath );
	}

	/**
	 * List each string of the input list with an increasing id in front.
	 * 
	 * @param stringList a List of Strings with the input data
	 * @param bufferedWriter a writer, already opened for output
	 * @throws IOException whenever write() or newLine() fail for the bufferedWriter 
	 */
	private void formatAndOutputInputStringList(List<String> stringList, BufferedWriter bufferedWriter) throws IOException {
		//
		int i = 1;
		for(String s: stringList) {
			bufferedWriter.write(i + ".\t" + s + "\n");
			i++;
		}
		bufferedWriter.write("--End--");
		bufferedWriter.newLine();
	}

}
